VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   Caption         =   "VB Directory ListView"
   ClientHeight    =   4800
   ClientLeft      =   2205
   ClientTop       =   2175
   ClientWidth     =   6105
   ClipControls    =   0   'False
   LinkTopic       =   "Form1"
   ScaleHeight     =   4800
   ScaleWidth      =   6105
   Begin ComctlLib.ListView ListView1 
      Height          =   2145
      Left            =   480
      TabIndex        =   2
      Top             =   1290
      Width           =   2295
      _ExtentX        =   4048
      _ExtentY        =   3784
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.FileListBox File1 
      Height          =   2040
      Left            =   3480
      TabIndex        =   1
      Top             =   1320
      Width           =   1875
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   480
      TabIndex        =   0
      Top             =   390
      Width           =   1995
   End
   Begin ComctlLib.ImageList ImageList1 
      Left            =   900
      Top             =   3840
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   327682
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
' Copyright  1997-1999 Brad Martinez, http://www.mvps.org
'
' Demonstrates how to fill the VB ListView with directories, emulating
' DirListBox functionality.

' We almost have the ListView looking and behaving exactly like a
' TreeView here, with the exception of:
'
'   - no tree lines
'   - folder icons are selected along with their labels
'   - there are no item tips for obscured labels
'
' ========================================================
' This project uses subclassing, and utilizes the services of the "Debug
' Object for AddressOf Subclassing" ActiveX server, Dbgwproc.dll, which
' allows unencumbered code execution when stepping through code in
' the VB IDE. This server is freely distributable and can be obtained from
' Microsoft at http://msdn.microsoft.com/vbasic/downloads/controls.asp.

' Set the conditional compilation argument:   DEBUGWINDOWPROC = 1
' in the project properties dialog/Make tab to enable the server's services.
' ========================================================

Private m_hwndLV As Long   ' ListView.hWnd
'

Private Sub Form_Load()
  Dim dwStyle As Long
  
  File1.Hidden = True
  File1.System = True
    
  ' Initialize the state ImageList
  With ImageList1
    .ImageWidth = 16
    .ImageHeight = 16
    .ListImages.Add Picture:=LoadPicture("Collapsed.ico")
    .ListImages.Add Picture:=LoadPicture("Expanded.ico")
  End With
  
  ' Initialize and fill up the ListView
  With ListView1
'    .BorderStyle = vbBSNone   ' set in designtime
    .ColumnHeaders.Add Text:="column"
    .LabelEdit = lvwManual
    .TabIndex = 1
    .View = lvwReport
    m_hwndLV = .hWnd
  End With
  
  ' Assign the VB ImageList as the ListView's state imagelist.
  Call ListView_SetImageList(m_hwndLV, ImageList1.hImageList, LVSIL_STATE)

  ' Tell the ListView that it will share the system small icon imagelist assigned
  ' to it, so that the ListView does not destroy the imagelist when it is itself
  ' destroyed, and remove the report view header
  dwStyle = GetWindowLong(m_hwndLV, gwl_style)
  If ((dwStyle And LVS_SHAREIMAGELISTS) = False) Then
    dwStyle = dwStyle Or LVS_SHAREIMAGELISTS
  End If
  Call SetWindowLong(m_hwndLV, gwl_style, dwStyle Or LVS_NOCOLUMNHEADER)
  
  ' Get the handle to the system's small icon imagelist and assign it to the
  ' ListView. We will set the ListItem image indices directly in InsertFolder.
  ' As far as the VB ListView's internal code is concerned, it's not using
  ' an imagelist.
  Call ListView_SetImageList(m_hwndLV, GetSystemImagelist(SHGFI_SMALLICON), LVSIL_SMALL)

  ' Subclass the ListView to catch various messages, and to prevent it from
  ' removing our system imagelist assignment (which it will do if left unchecked...)
  Call SubClass(m_hwndLV, AddressOf LVWndProc)
  
  ' And here we go...
  Call Drive1_Change

End Sub

' Goofiness...

Private Sub Form_Resize()
  On Error GoTo Out
  
  Call Drive1.Move(0, 0, ScaleWidth \ 2)
  Call ListView1.Move(0, Drive1.Height + 30, ScaleWidth \ 2, ScaleHeight - (Drive1.Height + 30))
  Call File1.Move(ListView1.Width + 30, 0, ScaleWidth - (ListView1.Width + 30), ScaleHeight)
  
Out:
End Sub

Private Sub Form_Unload(Cancel As Integer)
  
  ' Unsubclass the ListView
  Call UnSubClass(m_hwndLV)
  
  ' It is only necessary to remove the system imagelist associations from
  ' the ListView if its LVS_SHAREIMAGELISTS style is not set. If the bit
  ' was not set and we didn't do this, the ListView would destroy both
  ' imagelists (and that's why processes get system imagelist copies on NT)
  Call ListView_SetImageList(m_hwndLV, 0, LVSIL_SMALL)

  ' This speeds up unload a bit...
  Call ListView1.ListItems.Clear
  
End Sub

' Loads the ListView with the folders of the currently selected drive.

Private Sub Drive1_Change()
  Dim sDrive As String
  Static sPrevDrive As String
  
  ' Get the current drive and continue only if not the previous drive...
  sDrive = UCase(Left$(Drive1, 2) & vbBackslash)
  If (sDrive <> sPrevDrive) Then
    
    ' Determine if the drive is available...
    If IsFolderAvailable(sDrive) Then
     
     ' Save the current drive as the previous drive.
      sPrevDrive = sDrive
      
      ' Set the ListView's root folder and fill the FileListBox.
      Call InsertRootFolder(ListView1, sDrive)
      File1.Path = sDrive
      
    Else
      ' The drive is not available, show our msgbox.
      Call MsgBox(sDrive & " is unavailable.", vbExclamation)
  
      ' Restore the previous drive, will invoke this proc again.
      Drive1 = sPrevDrive
    
    End If   ' IsFolderAvailable
  End If   ' (sDrive <> sPrevDrive)
  
End Sub

' Fills the FileListBox with the selected folder's files.
' (Item.Tag was set in InsertFolder)

Private Sub ListView1_ItemClick(ByVal Item As ListItem)
  
  If IsFolderAvailable(Item.Tag) Then
    File1.Path = Item.Tag
  Else
    ' The folder's invalid, remove it, and resize the first column's width.
    Call ListView1.ListItems.Remove(Item.Index)
    Call ListView_AutosizeFirstColumn(m_hwndLV)
  End If

End Sub

' Toggles the expanded state of the parent item whose item state button
' was clicked with the left mouse button.

Private Sub ListView1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  Dim lvhti As LVHITTESTINFO
  Dim dwState As LVItemStates
  Dim iIndent As Long
    
  If (Button = vbLeftButton) Then
    
    ' Get the left clicked item
    lvhti.pt.x = x / Screen.TwipsPerPixelX
    lvhti.pt.y = y / Screen.TwipsPerPixelY
    Call ListView_HitTest(m_hwndLV, lvhti)   ' also returns iItem
    
    ' If the item's state icon was left-clicked...
    If (lvhti.flags = LVHT_ONITEMSTATEICON) Then
      
      ' Get the item's indent and state values
      dwState = ListView_GetItemStateEx(m_hwndLV, lvhti.iItem, iIndent)
      
      ' If the item is collaped, expanded it, otherwise collapse it
      If (dwState = lvisCollapsed) Then
        Call InsertSubfolders(ListView1, lvhti.iItem, iIndent, ListView1.HitTest(x, y).Tag)
      Else
        Call RemoveSubfolders(ListView1, lvhti.iItem, iIndent)
      End If
        
    End If   ' ListView_HitTest
  End If   ' (Button = vbLeftButton)
  
End Sub

' Toggles the expanded state of the parent item whose icon or label was
' double clicked with the left mouse button.

Private Sub ListView1_DblClick()
  Dim lvhti As LVHITTESTINFO
  Dim dwState As LVItemStates
  Dim iIndent As Long
  Dim li As ListItem
  
  ' If a left button double-click... (change to suit)
  If (GetKeyState(vbKeyLButton) And &H8000) Then
  
    ' Get the left clicked item
    Call GetCursorPos(lvhti.pt)
    Call ScreenToClient(m_hwndLV, lvhti.pt)
    Call ListView_HitTest(m_hwndLV, lvhti)  ' also returns iItem
    
    ' If the item's icon or label is double clicked...
    If (lvhti.flags And (LVHT_ONITEMICON Or LVHT_ONITEMLABEL)) Then
    
      ' Get the left clicked item's indent and state values
      dwState = ListView_GetItemStateEx(m_hwndLV, lvhti.iItem, iIndent)
      
      ' If the item is collaped, expanded it, otherwise collapse it
      If (dwState = lvisCollapsed) Then
        ' (the ListView's HitTest method *always* expects Twips)
        Set li = ListView1.HitTest(lvhti.pt.x * Screen.TwipsPerPixelX, lvhti.pt.y * Screen.TwipsPerPixelY)
        Call InsertSubfolders(ListView1, lvhti.iItem, iIndent, li.Tag)
      Else
        Call RemoveSubfolders(ListView1, lvhti.iItem, iIndent)
      End If
    
    End If   ' ListView_HitTest
  End If   ' (Button = vbLeftButton)
  
End Sub

' Toggles the expanded state of the selected parent item on keyboard input.

Friend Sub ListView1_KeyDown(KeyCode As Integer, Shift As Integer)
  Dim iItem As Long
  Dim dwState As LVItemStates
  Dim iIndent As Long
  
  ' Get the selected item...
  iItem = ListView_GetSelectedItem(m_hwndLV)
  If (iItem <> LVI_NOITEM) Then
    
    ' Get the item's indent and state values
    dwState = ListView_GetItemStateEx(m_hwndLV, iItem, iIndent)
  
    Select Case KeyCode
      
      ' The right arrow key expands the selected item, then selects the current item's first child
      Case vbKeyRight
        ' If the item is collaped, expanded it, otherwise select
        ' the first child of the selected item (if any)
        If (dwState = lvisCollapsed) Then
          Call InsertSubfolders(ListView1, iItem, iIndent, ListView1.SelectedItem.Tag)
        ElseIf (dwState = lvisExpanded) Then
          iItem = ListView_GetRelativeItem(m_hwndLV, iItem, lvriChild)
          If (iItem <> LVI_NOITEM) Then Call ListView_SetSelectedItem(m_hwndLV, iItem)
        End If
        
      ' The left arrow key collapses the selected item, then selects the current item's parent
      ' The backspace key only selects the current item's parent
      Case vbKeyLeft, vbKeyBack
        ' If vbKeyLeft and the item is expanded, collaped it, otherwise select
        ' the parent of the selected item (if any)
        If (KeyCode = vbKeyLeft) And (dwState = lvisExpanded) Then
          Call RemoveSubfolders(ListView1, iItem, iIndent)
        Else
          If iItem Then
            iItem = ListView_GetRelativeItem(m_hwndLV, iItem, lvriParent)
            If (iItem <> LVI_NOITEM) Then
              Call ListView_SetSelectedItem(m_hwndLV, iItem)
              Call ListView_EnsureVisible(m_hwndLV, iItem, False)
            End If
          End If
        End If
    
    End Select   ' KeyCode
  End If   ' (iItem <> LVI_NOITEM)
  
End Sub
