Attribute VB_Name = "Module1"
Option Explicit
'
' Copyright  1997-1999 Brad Martinez, http://www.mvps.org
'
Public Const vbBackslash = "\"
Public Const vbAscDot = 46   ' Asc(".") = 46 (vbKeyDelete)
Public Const vbAllFileSpec = "*.*"

Public Enum SortOrderConstants
  soAscending = 1
  soDescending = -1
End Enum

Public Type POINTAPI   ' pt
  x As Long
  y As Long
End Type

Public Type RECT   ' rct
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long
Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As KeyCodeConstants) As Integer

Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
                            (ByVal hWnd As Long, _
                            ByVal wMsg As Long, _
                            ByVal wParam As Long, _
                            lParam As Any) As Long   ' <---

Declare Function ImageList_GetIconSize Lib "comctl32.dll" (ByVal hIml As Long, lpcx As Long, lpcy As Long) As Boolean

' ===========================================================================
' FindFirstFile

Public Const MAX_PATH = 260

Public Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Public Type WIN32_FIND_DATA   'wfd
  dwFileAttributes As Long
  ftCreationTime As FILETIME
  ftLastAccessTime As FILETIME
  ftLastWriteTime As FILETIME
  nFileSizeHigh As Long
  nFileSizeLow As Long
  dwReserved0 As Long
  dwReserved1 As Long
  cFileName As String * MAX_PATH
  cShortFileName As String * 14
End Type

' WIN32_FIND_DATA.nFileSizeHigh:
' Specifies the high-order DWORD value of the file size, in bytes.
' This value is zero unless the file size is greater than MAXDWORD. The
' size of the file is equal to (nFileSizeHigh * MAXDWORD) + nFileSizeLow.
Public Const MAXDWORD = (2 ^ 32) - 1 ' = 0xFFFFFFFF, not &HFFFFFFFF ( -1)

' FindFirstFile failure rtn value
Public Const INVALID_HANDLE_VALUE = -1

Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

' ==============================================================
' SHGetFileInfo

'Public Const MAX_PATH = 260

Public Type SHFILEINFO   ' shfi
  hIcon As Long
  iIcon As Long
  dwAttributes As Long
  szDisplayName As String * MAX_PATH
  szTypeName As String * 80
End Type

' Retrieves information about an object in the file system, such as a file,
' a folder, a directory, or a drive root.
Declare Function SHGetFileInfo Lib "shell32" Alias "SHGetFileInfoA" _
                              (ByVal pszPath As Any, _
                              ByVal dwFileAttributes As Long, _
                              psfi As SHFILEINFO, _
                              ByVal cbFileInfo As Long, _
                              ByVal uFlags As Long) As Long

Public Enum SHGFI_flags
  SHGFI_LARGEICON = &H0            ' sfi.hIcon is large icon
  SHGFI_SMALLICON = &H1            ' sfi.hIcon is small icon
  SHGFI_OPENICON = &H2              ' sfi.hIcon is open icon
  SHGFI_SHELLICONSIZE = &H4      ' sfi.hIcon is shell size (not system size), rtns BOOL
  SHGFI_PIDL = &H8                        ' pszPath is pidl, rtns BOOL
  ' Indicates that the function should not attempt to access the file specified by pszPath.
  ' Rather, it should act as if the file specified by pszPath exists with the file attributes
  ' passed in dwFileAttributes. This flag cannot be combined with the SHGFI_ATTRIBUTES,
  ' SHGFI_EXETYPE, or SHGFI_PIDL flags <---- !!!
  SHGFI_USEFILEATTRIBUTES = &H10   ' pretend pszPath exists, rtns BOOL
  SHGFI_ICON = &H100                    ' fills sfi.hIcon, rtns BOOL, use DestroyIcon
  SHGFI_DISPLAYNAME = &H200    ' isf.szDisplayName is filled (SHGDN_NORMAL), rtns BOOL
  SHGFI_TYPENAME = &H400          ' isf.szTypeName is filled, rtns BOOL
  SHGFI_ATTRIBUTES = &H800         ' rtns IShellFolder::GetAttributesOf  SFGAO_* flags
  SHGFI_ICONLOCATION = &H1000   ' fills sfi.szDisplayName with filename
                                                        ' containing the icon, rtns BOOL
  SHGFI_EXETYPE = &H2000            ' rtns two ASCII chars of exe type
  SHGFI_SYSICONINDEX = &H4000   ' sfi.iIcon is sys il icon index, rtns hImagelist
  SHGFI_LINKOVERLAY = &H8000    ' add shortcut overlay to sfi.hIcon
  SHGFI_SELECTED = &H10000        ' sfi.hIcon is selected icon
  SHGFI_ATTR_SPECIFIED = &H20000    ' get only attributes specified in sfi.dwAttributes
End Enum

' ============================================================
' IShellFolder::GetAttributesOf shell attribute flags

Public Const DROPEFFECT_COPY = 1&
Public Const DROPEFFECT_MOVE = 2&
Public Const DROPEFFECT_LINK = 4&

Public Enum SFGAO_Flags

' Capability flags:
  SFGAO_CANCOPY = DROPEFFECT_COPY   ' Objects can be copied
  SFGAO_CANMOVE = DROPEFFECT_MOVE  ' Objects can be moved
  SFGAO_CANLINK = DROPEFFECT_LINK       ' Objects can have shortcuts
  SFGAO_CANRENAME = &H10&                      ' Objects can be renamed
  SFGAO_CANDELETE = &H20&                       ' Objects can be deleted
  SFGAO_HASPROPSHEET = &H40&               ' Objects have property sheets
  SFGAO_DROPTARGET = &H100&                  ' Objects are drop target
  SFGAO_CAPABILITYMASK = &H177&            ' Mask for the capability flags

  ' Display attributes:
  SFGAO_LINK = &H10000                             ' Is a shortcut (link)
  SFGAO_SHARE = &H20000                         ' Is shared
  SFGAO_READONLY = &H40000                  ' Is read-only   *** SHGFI, ISF.GAO for errDeviceNotReady = &H80070015
  SFGAO_GHOSTED = &H80000                    ' Is ghosted icon
  SFGAO_DISPLAYATTRMASK = &HF0000  ' Mask for the display attributes.

  ' Contents attributes (flags):
  SFGAO_FILESYSANCESTOR = &H10000000   ' Is a file system ancestor (local or remoted drive, desktop)
  SFGAO_FOLDER = &H20000000                       ' Is a folder.
  SFGAO_FILESYSTEM = &H40000000                ' Is a file system object (file/folder/root)
  SFGAO_HASSUBFOLDER = &H80000000        ' Expandable in the map pane
  SFGAO_CONTENTSMASK = &H80000000       ' Mask for contents attributes

  ' Miscellaneous attributes:
  SFGAO_VALIDATE = &H1000000           ' invalidate cached information
  SFGAO_REMOVABLE = &H2000000      ' Is removeable media, CD folders do not have this set,
                                                                   ' but child folders of net *drives* do (including mapped
                                                                   ' drives, but not the drive itself nor the net computer)!!
  SFGAO_COMPRESSED = &H4000000   ' Object is compressed (use alt color)

  SFGAO_ALL = &HFFFFFFFF   ' all available attributes, user-defined
End Enum
'

' ==============================================================
' SHGetFileInfo calls

' Returns a file's SFGAO_ attributes
'   sPath  - must be either an absolute path or absolute pidl

Public Function GetFileAttributes(sPath As String) As Long
  Dim sfi As SHFILEINFO
  If SHGetFileInfo(sPath, 0, sfi, Len(sfi), SHGFI_ATTRIBUTES) Then
    GetFileAttributes = sfi.dwAttributes
  End If
End Function

' Returns a file's display name (how the file is displayed
' in Explorer, equivalent to calling the GetFileTitle() api),
'   sPath  - must be either an absolute path or absolute pidl

Public Function GetFileDisplayName(sPath As String) As String
  Dim sfi As SHFILEINFO
  If SHGetFileInfo(sPath, 0, sfi, Len(sfi), SHGFI_DISPLAYNAME) Then
    GetFileDisplayName = GetStrFromBufferA(sfi.szDisplayName)
  End If
End Function

' Returns a file's small or large icon index within the system imagelist.
'   sPath  - must be either an absolute path or absolute pidl
'   uFlags    - either SHGFI_SMALLICON or SHGFI_LARGEICON, and SHGFI_OPENICON

Public Function GetFileIconIndex(sPath As String, uFlags As Long) As Long
  Dim sfi As SHFILEINFO
  If SHGetFileInfo(sPath, 0, sfi, Len(sfi), SHGFI_SYSICONINDEX Or uFlags) Then
    GetFileIconIndex = sfi.iIcon
  End If
End Function

' Returns the handle of the small or large icon system imagelist.
'   uFlags - either SHGFI_SMALLICON or SHGFI_LARGEICON

Public Function GetSystemImagelist(uFlags As Long) As Long
  Dim sfi As SHFILEINFO
  ' Any valid file system path can be used to retrieve system image list handles.
  GetSystemImagelist = SHGetFileInfo("C:\", 0, sfi, Len(sfi), SHGFI_SYSICONINDEX Or uFlags)
End Function

' ==============================================================
' miscellaneous calls

' Returns the string before first null char encountered (if any) from an ANSII string.

Public Function GetStrFromBufferA(sz As String) As String
  If InStr(sz, vbNullChar) Then
    GetStrFromBufferA = Left$(sz, InStr(sz, vbNullChar) - 1)
  Else
    ' If sz had no null char, the Left$ function
    ' above would return a zero length string ("").
    GetStrFromBufferA = sz
  End If
End Function

' Returns the larger of the two passed params

Public Function Max(param1 As Long, param2 As Long) As Long
  If param1 > param2 Then Max = param1 Else Max = param2
End Function

Public Function NormalizePath(sPath As String) As String
  If Right$(sPath, 1) <> vbBackslash Then
    NormalizePath = sPath & vbBackslash
  Else
    NormalizePath = sPath
  End If
End Function

Public Function IsFolderAvailable(sFolder As String) As Boolean
  On Error GoTo Out
  IsFolderAvailable = (GetAttr(sFolder) And vbDirectory)
Out:
End Function

' Sorts a string array using the shell sort algorithm.

' l   - low element in array (LBound)
' h  - high element in array (UBound)
' i   - 1st loop
' j   - 2nd loop
' k  - 3rd loop
' s  - temp element holder

Public Sub ShellSortStrings(astr() As String, l As Long, h As Long, dwSortOrder As SortOrderConstants)
  Dim j As Long
  Dim k As Long
  Dim i As Long
  Dim s As String
  
  i = 1
  Do Until (i > (h - l))
    i = (3 * i) + 1
  Loop
  
  Do
    i = i / 3
    
    For j = (l + i) To h
      s = astr(j)
      k = j
      
      Do While (StrComp(astr(k - i), s, vbTextCompare) = dwSortOrder)
        astr(k) = astr(k - i)
        k = k - i
        If (k < i) Then Exit Do
      Loop
      
      astr(k) = s
    Next
  
  Loop While i > 1

End Sub
